YurrCombatLog = LibStub("AceAddon-3.0"):NewAddon("YurrCombatLog", "AceConsole-3.0", "AceEvent-3.0")
local YurrCombatLogLDB = LibStub("LibDataBroker-1.1")
local L = LibStub("AceLocale-3.0"):GetLocale("YurrCombatLog")
local Addon = LibStub("AceAddon-3.0"):GetAddon("Fortress", "silent")
local math_floor = _G.math.floor

local LDB = YurrCombatLogLDB:NewDataObject("YurrCombatLogLDB", {
	icon = "Interface\\Icons\\Ability_MeleeDamage",
	label = "YurrCombatLogLDB",
	text = "YurrCombatLog"
})

function LDB:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOP", self, "BOTTOM")
	GameTooltip:ClearLines()
	GameTooltip:AddLine(LDB.text)
	GameTooltip:AddLine("|cffffff00"..L["LeftClick|r to open the YurrCombatLog options menu"])
	if ( Addon ) then
		GameTooltip:AddLine("|cffffff00"..L["RightClick|r to open the Fotress options menu"])
	end
	--LDB.OnTooltipShow(GameTooltip)
	GameTooltip:Show()
end

function LDB:OnClick(button)
	if button == "LeftButton" then
		LibStub("AceConfigDialog-3.0"):Open("YurrCombatLog")
	elseif ( Addon ) and button == "RightButton" then
		LibStub("AceConfigDialog-3.0"):Open("YurrCombatLogLDB")
	end
end

function LDB:OnLeave()
    GameTooltip:Hide()
end


local defaults = {
    profile = {
		
		ChatFrame = 2,
		timestamp = true,
		
		filters = {
			hit = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			heal = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			miss = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
						failed = {
				source = {
					Player = false,
				},
				victim = {
					Player = false,
				},
			},
			cast = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			gain = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			drain = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			leech = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			dispel = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			buff = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			debuff = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			fade = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			interrupt = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			death = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			environment = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			extra_attack = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			enchant = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
			create = {
				source = {
					Player = true,
				},
				victim = {
					Player = true,
				},
			},
		},
		
		events = {
			experience = true,
			faction = true,
			skill = true,
			honor = true,
		},
		
		watches = {
		},
		
		colors = {
			player = {
			["r"] = 0.50,
			["g"] = 0.50,
			["b"] = 1.00,
			},
			pet = {
			["r"] = 0.50,
			["g"] = 0.30,
			["b"] = 0.15,
			},
			raid = {
			["r"] = 1.00,
			["g"] = 0.44,
			["b"] = 0.20,
			},
			party = {
			["r"] = 0.65,
			["g"] = 1.00,
			["b"] = 0.65,
			},
			target = {
			["r"] = 1.00,
			["g"] = 0.46,
			["b"] = 1.00,
			},
--[[		targetoftarget {
			["r"] = 0.60,
			["g"] = 0.30,
			["b"] = 0.60,
			},]]--
			focus = {
			["r"] = 0.80,
			["g"] = 0.33,
			["b"] = 0.85,
			},
			other = {
			["r"] = 1.00,
			["g"] = 1.00,
			["b"] = 1.00,
			},
			physical = {
			["r"] = 1.00,
			["g"] = 1.00,
			["b"] = 1.00,
			},
			holy = {
			["r"] = 1.00,
			["g"] = 1.00,
			["b"] = 0.30,
			},
			fire = {
			["r"] = 1.00,
			["g"] = 0.15,
			["b"] = 0.18,
			},
			nature = {
			["r"] = 0.40,
			["g"] = 1.00,
			["b"] = 0.40,
			},
			frost = {
			["r"] = 0.30,
			["g"] = 0.30,
			["b"] = 0.90,
			},
			shadow = {
			["r"] = 1.00,
			["g"] = 0.70,
			["b"] = 1.00,
			},
			arcane = {
			["r"] = 0.75,
			["g"] = 0.75,
			["b"] = 0.75,
			},
			heal = {
			["r"] = 1.00,
			["g"] = 1.00,
			["b"] = 0.30,
			},
			miss = {
			["r"] = 1.00,
			["g"] = 0.5,
			["b"] = 0.5,
			},
			buff = {
			["r"] = 0.20,
			["g"] = 1.00,
			["b"] = 0.20,
			},
			debuff = {
			["r"] = 1.00,
			["g"] = 0.20,
			["b"] = 0.20,
			},
			skill = {
			["r"] = 1.00,
			["g"] = 1.00,
			["b"] = 0.4,
			},
			dirty = {
			["r"] = 0.93,
			["g"] = 0.65,
			["b"] = 0.37,
			},
			timestampColor = {
			r = 0.45,
			g = 0.45,
			b = 0.45,
			},
		},
		
		miniMap = {
		dragable = true,
		angle = 0,
		radius = 80,
		rounding = 10,
		Hidden = false
		}
	}
}

local options = {
	type = "group",
	name = "YurrCombatLog",
	childGroups = "tree",
	args = {
		YurrCombatLog = {
		type = "group",
		name = "YurrCombatLog",
		handler = YurrCombatLog,
			args = {
				YurrCombatLog = {
					type = "group",
					name = "YurrCombatLog",
					order = 1,
					inline = true,
					args = {
						chatFrame = {
							type = "select",
							name = L["ChatFrame"],
							desc = "Select where you want your CombatLog output.",
							values = { "ChatFrame1", "ChatFrame2", "ChatFrame3", "ChatFrame4", "ChatFrame5", "ChatFrame6", "ChatFrame7" },
							get = function()
								return YurrCombatLog.db.profile.ChatFrame
							end,
							set = function(info, value)
								outputFrame = YurrCombatLog:ChatFrame(YurrCombatLog.db.profile.ChatFrame)
								YurrCombatLog.db.profile.ChatFrame = value
							end,
						},
						timestamp = {
							type = "toggle",
							name = "Timestamp",
							get = function()
								return YurrCombatLog.db.profile.timestamp
							end,
							set = function(info, value)
								YurrCombatLog.db.profile.timestamp = value
							end,
						},
						timestampColor = {
							type = "color",
							name = "Timestamp Color",
							get = "getColor",
							set = "setColor",
						},
					},
				},
				filters = {
				type = "group",
				order = 1,
				name = L["Filters"],
					args = {
						any = {
						type = "group",
						name = L["*"],
						desc = L["Name Filters for *"],
						order = 1,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for *"],
								order = 1,
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										order = 1,
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										order = 2,
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 2,
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												},
											},
										},
									},
								},
							},
						},
						hit = {
						type = "group",
						name = L["Hit"],
						desc = L["Name Filters for Hit"],
						order = 2,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Hit"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						heal = {
						type = "group",
						name = L["Heal"],
						desc = L["Name Filters for Heal"],
						order = 3,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Heal"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						miss = {
						type = "group",
						name = L["Miss"],
						desc = L["Name Filters for Miss"],
						order = 4,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Miss"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						failed = {
						type = "group",
						name = L["Failed"],
						desc = L["Name Filters for Failed"],
						order = 4,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Failed"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						cast = {
						type = "group",
						name = L["Cast"],
						desc = L["Name Filters for Cast"],
						order = 5,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Cast"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						gain = {
						type = "group",
						name = L["Gain"],
						desc = L["Name Filters for Gain"],
						order = 6,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Gain"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						drain = {
						type = "group",
						name = L["Drain"],
						desc = L["Name Filters for Drain"],
						order = 7,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Drain"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						leech = {
						type = "group",
						name = L["Leech"],
						desc = L["Name Filters for Leech"],
						order = 8,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Leech"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						dispel = {
						type = "group",
						name = L["Dispel"],
						desc = L["Name Filters for Dispel"],
						order = 9,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Dispel"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						buff = {
						type = "group",
						name = L["Buff"],
						desc = L["Name Filters for Buff"],
						order = 10,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Buff"],
								inline = true,
									args = {
										--[[source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},]]--
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						debuff = {
						type = "group",
						name = L["Debuff"],
						desc = L["Name Filters for Debuff"],
						order = 11,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Debuff"],
								inline = true,
									args = {
										--[[source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},]]--
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						fade = {
						type = "group",
						name = L["Fade"],
						desc = L["Name Filters for Fade"],
						order = 12,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Fade"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						interrupt = {
						type = "group",
						name = L["Interrupt"],
						desc = L["Name Filters for Interrupt"],
						order = 13,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Interrupt"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						death = {
						type = "group",
						name = L["Death"],
						desc = L["Name Filters for Death"],
						order = 14,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Death"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						environment = {
						type = "group",
						name = L["Environment"],
						desc = L["Name Filters for Environment"],
						order = 15,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Environment"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						extra_attack = {
						type = "group",
						name = L["Extra Attack"],
						desc = L["Name Filters for Extra Attack"],
						order = 16,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Extra Attack"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						enchant = {
						type = "group",
						name = L["Enchant"],
						desc = L["Name Filters for Enchant"],
						order = 17,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Enchant"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
						create = {
						type = "group",
						name = L["Create"],
						desc = L["Name Filters for Create"],
						order = 18,
							args = {
								Description = {
								type = "group",
								name = L["Name Filters for Create"],
								inline = true,
									args = {
										source = {
										type = "group",
										name = L["Source"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
										victim = {
										type = "group",
										name = L["Victim"],
										inline = true,
											args = {
												Player = {
												type = "toggle",
												name = L["Player"],
												order = 1,
												set = "setFilter",
												get = "getFilter",
												},
												Pet = {
												type = "toggle",
												name = L["Pet"],
												order = 2,
												set = "setFilter",
												get = "getFilter",
												},
												Part = {
												type = "toggle",
												name = L["Party"],
												order = 3,
												set = "setFilter",
												get = "getFilter",
												},
												Raid = {
												type = "toggle",
												name = L["Raid"],
												order = 4,
												set = "setFilter",
												get = "getFilter",
												},
												Target = {
												type = "toggle",
												name = L["Target"],
												order = 5,
												set = "setFilter",
												get = "getFilter",
												},
												TargetofTarget = {
												type = "toggle",
												name = L["Target of Target"],
												order = 6,
												set = "setFilter",
												get = "getFilter",
												},
												Focus = {
												type = "toggle",
												name = L["Focus"],
												order = 7,
												set = "setFilter",
												get = "getFilter",
												},
												Others = {
												type = "toggle",
												name = L["Others"],
												order = 8,
												set = "setFilter",
												get = "getFilter",
												},
											},
										},
									},
								},
							},
						},
					},
				},
				events = {
					type = "group",
					order = 2,
					name = L["Events"],
					args = {
						events = {
							type = "group",
							name = L["Events"],
							order = 1,
							inline = true,
							args = {
								experience = {
									type = "toggle",
									order = 1,
									name = L["Experience"],
									set = "setEvents",
									get = "getEvents",
								},
								combat = {
									type = "toggle",
									order = 1,
									name = L["Combat"],
									get = function()
									return YurrCombatLog.db.profile.events.combat
								end,
								set = function(info, value)
									YurrCombatLog.db.profile.events.combat = value
								end,
								},
								faction = {
									type = "toggle",
									order = 1,
									name = L["Faction"],
									get = function()
									return YurrCombatLog.db.profile.events.faction
								end,
								set = function(info, value)
									YurrCombatLog.db.profile.events.faction = value
								end,
								},
								skill = {
									type = "toggle",
									order = 1,
									name = L["Skill"],
									get = function()
									return YurrCombatLog.db.profile.events.skill
								end,
								set = function(info, value)
									YurrCombatLog.db.profile.events.skill = value
								end,
								},
								honor = {
									type = "toggle",
									order = 1,
									name = L["Honor"],
									get = function()
									return YurrCombatLog.db.profile.events.honor
								end,
								set = function(info, value)
									YurrCombatLog.db.profile.events.honor = value
								end,
								},
							},
						},
					},
				},
				colors = {
				type = "group",
				name = L["Colors"],
				order = 3,
					args = {
						Affiliation = {
						type = "group",
						name = L["Affiliation"],
						inline = true,
							args = {
								player = {
								type = "color",
								name = L["Player"],
								set = "setColor",
								get = "getColor",
								order = 1,
								},
								pet = {
								type = "color",
								name = L["Pet"],
								set = "setColor",
								get = "getColor",
								order = 2,
								},
								raid = {
								type = "color",
								name = L["Raid"],
								set = "setColor",
								get = "getColor",
								order = 3,
								},
								party = {
								type = "color",
								name = L["Party"],
								set = "setColor",
								get = "getColor",
								order = 4,
								},
								target = {
								type = "color",
								name = L["Target"],
								set = "setColor",
								get = "getColor",
								order = 5,
								},
								--[[targettarget = {
								type = "color",
								name = L["Target of Target"],
								set = "setColor",
								get = "getColor",
								order = 6,
								},]]--
								focus = {
								type = "color",
								name = L["Focus"],
								set = "setColor",
								get = "getColor",
								order = 7,
								},
								other = {
								type = "color",
								name = L["Other"],
								set = "setColor",
								get = "getColor",
								order = 8,
								},
							}
						},
						School = {
						type = "group",
						name = L["School"],
						inline = true,
							args = {
								physical = {
								type = "color",
								name = L["Physical"],
								set = "setColor",
								get = "getColor",
								order = 1,
								},
								holy = {
								type = "color",
								name = L["Holy"],
								set = "setColor",
								get = "getColor",
								order = 2,
								},
								fire = {
								type = "color",
								name = L["Fire"],
								set = "setColor",
								get = "getColor",
								order = 3,
								},
								nature = {
								type = "color",
								name = L["Nature"],
								set = "setColor",
								get = "getColor",
								order = 4,
								},
								frost = {
								type = "color",
								name = L["Frost"],
								set = "setColor",
								get = "getColor",
								order = 5,
								},
								shadow = {
								type = "color",
								name = L["Shadow"],
								set = "setColor",
								get = "getColor",
								order = 6,
								},
								arcane = {
								type = "color",
								name = L["Arcane"],
								set = "setColor",
								get = "getColor",
								order = 7,
								},
							}
						},
						Type = {
						type = "group",
						name = L["Type"],
						inline = true,
							args = {
								heal = {
								type = "color",
								name = L["Heal"],
								set = "setColor",
								get = "getColor",
								order = 1,
								},
								miss = {
								type = "color",
								name = L["Miss"],
								set = "setColor",
								get = "getColor",
								order = 2,
								},
								buff = {
								type = "color",
								name = L["Buff"],
								set = "setColor",
								get = "getColor",
								order = 3,
								},
								debuff = {
								type = "color",
								name = L["Debuff"],
								set = "setColor",
								get = "getColor",
								order = 4,
								},
								skill = {
								type = "color",
								name = L["Skill"],
								set = "setColor",
								get = "getColor",
								order = 5,
								},
								--[[dirty = {
								type = "color",
								name = L["Dirty"],
								set = "setColor",
								get = "getColor",
								order = 6,
								},]]--
							}
						}
					}
				},
--[[				format = {
					order = 4,
				},--]]
				watches = {
					type = "group",
					name = L["Watches"],
					order = 5,
					args = {
						watches = {
							type = "group",
							name = L["Watches"],
							order = 1,
							inline = true,
							args = {
								addName = {
								type = "input",
								name = L["addName"],
								order = 1,
								set = function(info, value) YurrCombatLog.db.profile.watches[value] = value
								end,
								get = function() end,
								},
								removeName = {
								type = "input",
								name = L["removeName"],
								order = 2,
								set = function(info, value) YurrCombatLog.db.profile.watches[value] = nil
								end,
								get = function() end,
								},
								listnames = {
								type = "header",
								name = function()
									local newvalue = ""
									for key,value in pairs(YurrCombatLog.db.profile.watches) do newvalue = value..", "..newvalue end
									return newvalue
								end,
								order = 3,
								},
							},
						},
					},
				},
				minimap = {	-- jacked from Omen
					type = "group",
					name = L["Minimap Options"],
					order = -1,
						args = {
							minimap = {
							type = "group",
							name = L["Minimap Options"],
							order = 1,
							inline = true,
							args = {
								hideIcon = {
									type = "toggle",
									name = L["Hide minimap icon"],
									desc = L["Hide minimap icon"],
									get = function(info) 
										return YurrCombatLog.db.profile.miniMap.Hidden
									end,
									set = function(info, value)
										YurrCombatLog.db.profile.miniMap.Hidden = value
										if ( YurrCombatLog.db.profile.miniMap.Hidden == true ) then
											YurrCombatLog:HideMinimap()
										elseif ( YurrCombatLog.db.profile.miniMap.Hidden == false ) then
											YurrCombatLog:ShowMinimap()
										end
									end,
								},
							}
						}
					}
				}
			}
		}
	}
}

function YurrCombatLog:OnInitialize()

	-- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("YurrCombatLogDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("YurrCombatLog", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("YurrCombatLog", "YurrCombatLog")
	self:RegisterChatCommand("ycl", "ChatCommand")
	self:RegisterChatCommand("yurrcombatlog", "ChatCommand")

end

function YurrCombatLog:OnEnable()

	-- Called when the addon is enabled
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN")
	self:RegisterEvent("CHAT_MSG_COMBAT_HONOR_GAIN")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("CHAT_MSG_SKILL")
	CombatLogClearEntries()
	outputFrame = self:ChatFrame(self.db.profile.ChatFrame)
	
	local updatePeriod, elap = 0.1, 0
	ChatFrame2:SetScript("OnUpdate", 
		function(self, elapsed)

			elap = elap + elapsed
			--if elap < updatePeriod then return end
			if CombatLogQuickButtonFrame_Custom:Hide() == 0 then return end
			CombatLogQuickButtonFrame_Custom:Hide()
			for i=1, COMBATLOG:GetNumPoints() do
			   point,relativeTo,relativePoint,xOfs,yOfs = COMBATLOG:GetPoint(i)
			   if ( point == "TOPLEFT" ) then 
			      break;
			   end
			end
			if ( COMBATLOG.isDocked ) then
			   COMBATLOG:SetPoint("TOPLEFT", relativeTo, relativePoint, 0, 0);
			end
			_G[COMBATLOG:GetName().."Background"]:SetPoint("TOPLEFT", COMBATLOG, "TOPLEFT", -2, 3);
			_G[COMBATLOG:GetName().."Background"]:SetPoint("TOPRIGHT", COMBATLOG, "TOPRIGHT", 2, 0);
		end
	)
	
	self:Minimap()


end

--Disable stuff
function YurrCombatLog:ADDON_LOADED(events, addonName)

	local events, addonName = events, addonName

	if addonName == "Blizzard_CombatLog" then
		COMBATLOG:UnregisterEvent("COMBAT_LOG_EVENT")
		COMBATLOG:SetScript("OnEvent", nil)
		CombatLogQuickButtonFrame_Custom:Hide()
		Blizzard_CombatLog_AdjustCombatLogHeight = fakeFunction
		CombatLog_AddEvent = fakeFunction
		Blizzard_CombatLog_Refilter = fakeFunction
	end

end

--Hook stuff
function fakeFunction()
end

function YurrCombatLog:ChatFrame(frame)

	local frame = frame

	if frame == 1 then
		frame = ChatFrame1
	elseif frame == 2 then
		frame = ChatFrame2
	elseif frame == 3 then
		frame = ChatFrame3
	elseif frame == 4 then
		frame = ChatFrame4
	elseif frame == 5 then
		frame = ChatFrame5
	elseif frame == 6 then
		frame = ChatFrame6
	elseif frame == 7 then
		frame = ChatFrame7
	end
	return frame

end

function YurrCombatLog:ChatCommand(input)

	local input = input

	if not input or input:trim() == "" then
	  LibStub("AceConfigDialog-3.0"):Open("YurrCombatLog")
	else
	  LibStub("AceConfigCmd-3.0").HandleCommand(YurrCombatLog, "ycl", "YurrCombatLog", input)
	end

end

--credits to Kernelerror from my guild HappyFunRock
function YurrCombatLog:isChecked(eventType, sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)

	local eventType, sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName = eventType, sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName

	if ( self.db.profile.watches[sourceName] ) then return true end
	if ( self.db.profile.watches[destName] ) then return true end
	
	--Player
	if (self.db.profile.filters[eventType].source.Player == true and sourceGUID == UnitGUID("Player"))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Player == true and destGUID == UnitGUID("Player")) then
		return true;
	--Pet
	elseif (self.db.profile.filters[eventType].source.Pet == true and CombatLog_Object_IsA(sourceFlags, isPet)) then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Pet == true and CombatLog_Object_IsA(destGUID, isPet)) then
		return true;
	--Party
	elseif (self.db.profile.filters[eventType].source.Party == true and CombatLog_Object_IsA(sourceFlags, isParty))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Party == true and destGUID == CombatLog_Object_IsA(destGUID, isParty)) then
		return true;
	--Raid
	elseif (self.db.profile.filters[eventType].source.Raid == true and CombatLog_Object_IsA(sourceFlags, isRaid))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Raid == true and CombatLog_Object_IsA(destGUID, isRaid)) then
		return true;
	--Other
	elseif (self.db.profile.filters[eventType].source.Other == true and CombatLog_Object_IsA(sourceFlags, isOther))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Other == true and CombatLog_Object_IsA(destGUID, isOther)) then
		return true;
	--Target
	elseif (self.db.profile.filters[eventType].source.Target == true and CombatLog_Object_IsA(sourceGUID, isTarget)) then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Target == true and CombatLog_Object_IsA(destGUID, isTarget)) then
		return true;
	--Focus
	elseif (self.db.profile.filters[eventType].source.Focus == true and CombatLog_Object_IsA(sourceFlags, isFocus))  then
		return true;
	elseif (self.db.profile.filters[eventType].victim.Focus == true and CombatLog_Object_IsA(destGUID, isFocus)) then
		return true;
	end
	
	
	--if it doesnt confirm to any IF statement
	return false;

end

	--Converts 4 floats into FF code
function YurrCombatLog:CombatLog_Color_FloatToText(r,g,b,a)

	if ( type(r) == "table" ) then
		r, g, b, a = r.r, r.g, r.b, r.a;
	end
	a = min(1, a or 1) * 255
	r = min(1, r) * 255
	g = min(1, g) * 255
	b = min(1, b) * 255
	
	-- local fmt = "%.2x";
	return ("%.2x%.2x%.2x%.2x"):format(math_floor(a), math_floor(r), math_floor(g), math_floor(b))

end

--Color unit by flags
function YurrCombatLog:colorUnit(name, flags)

	local name = name
	local flags = flags
	local playerColor
	local petColor
	local partyColor
	local raidColor
	local otherColor
	local targetColor
	local focusColor
	local playerColored
	
	if CombatLog_Object_IsA(flags, isPlayer) then
		playerColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.player.r, self.db.profile.colors.player.g, self.db.profile.colors.player.b)
		playerColored = "|c"..playerColor..name.."|r"
		return playerColored
		
	elseif CombatLog_Object_IsA(flags, isPet) then
		petColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.pet.r, self.db.profile.colors.pet.g, self.db.profile.colors.pet.b)
		petColored = "|c"..petColor..name.."|r"
		return petColored
		
	elseif CombatLog_Object_IsA(flags, isParty) then
		partyColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.party.r, self.db.profile.colors.party.g, self.db.profile.colors.party.b)
		partyColored = "|c"..partyColor..name.."|r"
		return partyColored
		
	elseif CombatLog_Object_IsA(flags, isRaid) then
		raidColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.raid.r, self.db.profile.colors.raid.g, self.db.profile.colors.raid.b)
		raidColored = "|c"..raidColor..name.."|r"
		return raidColored
		
	elseif CombatLog_Object_IsA(flags, isTarget) then
		targetColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.target.r, self.db.profile.colors.target.g, self.db.profile.colors.target.b)
		targetColored = "|c"..targetColor..name.."|r"
		return targetColored
		
	elseif CombatLog_Object_IsA(flags, isOther) then
		otherColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.other.r, self.db.profile.colors.other.g, self.db.profile.colors.other.b)
		otherColored = "|c"..otherColor..name.."|r"
		return otherColored
		
	elseif CombatLog_Object_IsA(flags, isFocus) then
		focusColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.focus.r, self.db.profile.colors.focus.g, self.db.profile.colors.focus.b)
		focusColored = "|c"..focusColor..name.."|r"
		return focusColored
	end

end

function YurrCombatLog:SwingMissType(missType)

	local missType = missType
	local missed

	missed = (string.lower(missType))
	return missed

end

--Color anything via school
function YurrCombatLog:colorSpellName(school, name)

	local school, name, nameColored, newNameColored, colored = school, name, nil, nil, nil
	local physical, holy, fire, nature, frost, shadow, arcane, newNameColored
	local colored = {}
	
	if type(name) == number then
		name = tostring(name)
	end
	
	if name == nil then
		name = L["Melee"]
	end

	if school == 1 then
		physical = self:CombatLog_Color_FloatToText(self.db.profile.colors.physical.r, self.db.profile.colors.physical.g, self.db.profile.colors.physical.b)
		nameColored = "|c"..physical..name.."|r" --physical
	elseif school == 2 then
		holy = self:CombatLog_Color_FloatToText(self.db.profile.colors.holy.r, self.db.profile.colors.holy.g, self.db.profile.colors.holy.b)
		nameColored = "|c"..holy..name.."|r" --holy
	elseif school == 4 then
		fire = self:CombatLog_Color_FloatToText(self.db.profile.colors.fire.r, self.db.profile.colors.fire.g, self.db.profile.colors.fire.b)
		nameColored = "|c"..fire..name.."|r" --fire
	elseif school == 8 then
		nature = self:CombatLog_Color_FloatToText(self.db.profile.colors.nature.r, self.db.profile.colors.nature.g, self.db.profile.colors.nature.b)
		nameColored = "|c"..nature..name.."|r" --nature
	elseif school == 16 then
		frost = self:CombatLog_Color_FloatToText(self.db.profile.colors.frost.r, self.db.profile.colors.frost.g, self.db.profile.colors.frost.b)
		nameColored = "|c"..frost..name.."|r" --frost
	elseif school == 32 then
		shadow = self:CombatLog_Color_FloatToText(self.db.profile.colors.shadow.r, self.db.profile.colors.shadow.g, self.db.profile.colors.shadow.b)
		nameColored = "|c"..shadow..name.."|r" --shadow
	elseif school == 64 then
		arcane = self:CombatLog_Color_FloatToText(self.db.profile.colors.arcane.r, self.db.profile.colors.arcane.g, self.db.profile.colors.arcane.b)
		nameColored = "|c"..arcane..name.."|r" --arcane 
	end
	newNameColored = nameColored
	return newNameColored

end

--Color buffs by Buff/Debuff
function YurrCombatLog:buffColoring(buffName, buffType, amount)

	local buffName = buffName
	local buffType = buffType
	local amount = amount
	local buff
	local buffNameColored
	local buffColor
	
	if buffType == "BUFF" or buffType == nil then
		buffColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.buff.r, self.db.profile.colors.buff.g, self.db.profile.colors.buff.b)
		
	elseif buffType == "DEBUFF" then
		buffColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.debuff.r, self.db.profile.colors.debuff.g, self.db.profile.colors.debuff.b)
	end
	
	buffNameColored = "|c"..buffColor.." ++ "..buffName.."AMOUNT|r"
	
	if (amount) then
		buffNameColored = string.gsub(buffNameColored, "(AMOUNT)", "("..amount..")")
	else
		buffNameColored = string.gsub(buffNameColored, "(AMOUNT)", (""))
	end
	
	return buffNameColored

end

--Color enchants
function YurrCombatLog:EnchantColoring(enchantName, eventType)

	local enchantName, eventType = enchantName, eventType
	local enchant, enchantNameColored

	if eventType == "ENCHANT_APPLIED" then
		enchant = self:CombatLog_Color_FloatToText(self.db.profile.colors.skill.r, self.db.profile.colors.skill.g, self.db.profile.colors.skill.b)
		enchantNameColored = "|c"..enchant..enchantName.."|r"
	elseif eventType == "ENCHANT_REMOVED" then
		enchant = self:CombatLog_Color_FloatToText(self.db.profile.colors.skill.r, self.db.profile.colors.skill.g, self.db.profile.colors.skill.b)
		enchantNameColored = "|c"..enchant..enchantName.."|r"
	end
	return enchantNameColored

end

--returns environmental damage types
function YurrCombatLog:EnvironmentalDamageType(environmentalType)

	local environmentalType = environmentalType

	if environmentalType == "DROWNING" then
		environmentalType = "drown"
	elseif environmentalType == "FALLING" then
		environmentalType = "fall"
	elseif environmentalType == "FATIGUE" then
		environmentalType = "fatigue"
	elseif environmentalType == "FIRE" then
		environmentalType = "fire"
	elseif environmentalType == "LAVA" then
		environmentalType = "lava"
	elseif environmentalType == "SLIME" then
		environmentalType = "slime"
	end
	return environmentalType

end

-- NEEDS_IMPROVEMENT
function YurrCombatLog:powerType(powerType)

	local powerType = powerType

	if powerType == -2 then
		powerType = L["Health"] 
	elseif powerType == 0 then
		powerType = L["Mana"] 
	elseif powerType == 1 then
		powerType = L["Rage"]
	elseif powerType == 2 then
		powerType = L["Focus"]
	elseif powerType == 3 then
		powerType = L["Energy"]
	elseif powerType == 4 then
		powerType = L["Pet happiness "]
	end

end

function YurrCombatLog:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)

	local resisted = resisted
	local blocked = blocked
	local absorbed = absorbed
	local critical = critical
	local glancing = glancing
	local crushing = crushing
	local partialDamage
	
	if ( resisted ) then
		resisted = "(R"..resisted..")"
	else 
		resisted = ""
	end
	if ( blocked ) then
		blocked = "(B"..blocked..")"
	else 
		blocked = ""
	end
	if ( absorbed ) then
		absorbed = "(A"..absorbed..")"
	else 
		absorbed = ""
	end
	--[[if ( critical ) then
		critical = "Crit"
	else 
		critical = ""
	end]]--
	if ( glancing ) then
		glancing = "(G)"
	else 
		glancing = ""
	end
	if ( crushing ) then
		crushing = "(C)"
	else 
		crushing = ""
	end
	
	partialDamage = resisted..blocked..absorbed..glancing..crushing
	return partialDamage

end

--parse the event
function YurrCombatLog:COMBAT_LOG_EVENT_UNFILTERED(arg1, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)

	local event = event
	local sourceGUID = sourceGUID
	local sourceName = sourceName
	local sourceFlags = sourceFlags
	local destGUID = destGUID
	local destName = destName
	local destFlags = destFlags
	local amount
	local school
	local resisted
	local blocked
	local absorbed
	local critical
	local glancing
	local crushing
	local source
	local dest
	local spellNameColored
	local meleeName
	local amountColored
	local damageType
	local missed
	local extraSpellId
	local extraSpellName
	local extraSpellSchool
	local extraSpellNameColored
	local environmentalType

	local output

	--sourceNameColored = self:colorUnit(sourceName, sourceFlags)
	--destNameColored = self:colorUnit(destName, destFlags)

	if ( event == "SWING_DAMAGE" ) and (self:isChecked("hit", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		meleeName = self:colorSpellName(school)
		amountColored = self:colorSpellName(school, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..meleeName.." "..critical.."[DEST_NAME] "..amountColored..partialDamage
		
	elseif ( event == "SWING_MISSED" ) and (self:isChecked("miss", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		missType = ...
		missed = self:SwingMissType(missType)
		if missed == "miss" then
			output = "[SOURCE_NAME] "..missed.." [DEST_NAME] "
		else
			output = "[DEST_NAME] "..missed.." [SOURCE_NAME] "
		end
		
	elseif ( event == "RANGE_DAMAGE" ) and (self:isChecked("hit", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		amountColored = self:colorSpellName(spellSchool, amount)
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical.."[DEST_NAME] "..amountColored..partialDamage
		
	elseif ( event == "RANGE_MISSED" ) and (self:isChecked("miss", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, missType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		missed = self:SwingMissType(missType)
		if missed == "miss" then
			output = "[SOURCE_NAME] "..spellNameColored.." "..missed.." [DEST_NAME]"
		else
			output = "[SOURCE_NAME] "..spellNameColored.." [DEST_NAME] "..missed
		end
		
	elseif ( event == "SPELL_DAMAGE" ) and (self:isChecked("cast", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		--spellNameColored = self:colorSpellName(spellSchool, spellName)
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical.."[DEST_NAME] "..amountColored..partialDamage
		
	elseif ( event == "SPELL_MISSED" ) and (self:isChecked("miss", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, missType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		missed = self:SwingMissType(missType)
		if missed == "miss" then
			output = "[SOURCE_NAME] "..spellNameColored.." "..missed.." [DEST_NAME]"
		else
			output = "[SOURCE_NAME] "..spellNameColored.." [DEST_NAME] "..missed
		end
		
	elseif ( event == "SPELL_HEAL" ) and (self:isChecked("heal", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, critical = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = "Crit " amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical.."[DEST_NAME] "..amountColored
		
	elseif ( event == "SPELL_ENERGIZE" ) and (self:isChecked("gain", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, powerType = ...
		if powerType == -2 then powerType = L["Health"] elseif powerType == 0 then powerType = L["Mana"] elseif powerType == 1 then powerType = L["Rage"] elseif powerType == 2 then powerType = L["Focus"] elseif powerType == 3 then powerType = L["Energy"] elseif powerType == 4 then powerType = L["Pet happiness "] end
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." : [DEST_NAME] + "..amountColored.." "..powerType
		
	elseif ( event == "SPELL_PERIODIC_MISSED" ) and (self:isChecked("miss", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, missType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		missed = self:SwingMissType(missType)
		if missed == " miss " then
			output = "[SOURCE_NAME] "..spellNameColored..missed.." [DEST_NAME]"
		else
			output = "[SOURCE_NAME] "..spellNameColored.." [DEST_NAME] "..missed
		end
		
	elseif ( event == "SPELL_PERIODIC_DAMAGE" ) and (self:isChecked("cast", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(school, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Dot"].." [DEST_NAME] ~"..amountColored.."~"..partialDamage
		
	elseif ( event == "SPELL_PERIODIC_HEAL" ) and (self:isChecked("heal", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, critical = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["regen"].." [DEST_NAME] ~"..amountColored.."~"
		
	elseif ( event == "SPELL_PERIODIC_DRAIN" ) and (self:isChecked("drain", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Drain"].." [DEST_NAME] ~"..amountColored.."~"
		
	elseif ( event == "SPELL_PERIODIC_LEECH" ) and (self:isChecked("leech", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Leech"].." [DEST_NAME] ~"..amountColored.."~"
		
	elseif ( event == "SPELL_PERIODIC_ENERGIZE" ) and (self:isChecked("gain", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, powerType = ...
		if powerType == -2 then powerType = L["Health"] elseif powerType == 0 then powerType = L["Mana"] elseif powerType == 1 then powerType = L["Rage"] elseif powerType == 2 then powerType = L["Focus"] elseif powerType == 3 then powerType = L["Energy"] elseif powerType == 4 then powerType = L["Pet happiness "] end
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." : [DEST_NAME] + "..amountColored.." "..powerType
		
	elseif ( event == "SPELL_DRAIN" ) and (self:isChecked("drain", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Drain"].." [DEST_NAME] "..amountColored
		
	elseif ( event == "SPELL_LEECH" ) and ( self:isChecked("leech", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, powerType, extraAmount = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical..L["Leech"].." [DEST_NAME] "..amountColored
		
	elseif ( event == "SPELL_INTERRUPT" ) and (self:isChecked("interrupt", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool = ...
		extraSpellNameColored = self:colorSpellName(extraSpellSchool, extraSpellName)
		output = "[SOURCE_NAME] "..L["interrupt"].." [DEST_NAME] "..extraSpellNameColored
		
	elseif ( event == "SPELL_EXTRA_ATTACKS" ) and (self:isChecked("extra_attack", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount = ...
		amountColored = self:colorSpellName(spellSchool, amount)
		output = "[SOURCE_NAME] "..L["+ 1 attacks"].." ("..amountColored..")"
		
	elseif ( event == "SPELL_INSTAKILL" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_DURABILITY_DAMAGE" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_DURABILITY_DAMAGE_ALL" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_DISPEL_FAILED" ) and ( self:isChecked("dispel", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool = ...
		extraSpellNameColored = self:colorSpellName(extraSpellSchool, extraSpellName)
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		output = "[SOURCE_NAME] "..spellNameColored.." "..extraSpellNameColored.." [DEST_NAME]"..L["failed"]
		
	elseif ( event == "SPELL_AURA_DISPELLED" ) and (self:isChecked("dispel", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool, auraType = ...
		extraSpellNameColored = self:colorSpellName(extraSpellSchool, extraSpellName)
		output = "[SOURCE_NAME] "..L["dispel "]..extraSpellNameColored.." [DEST_NAME]"
		
	elseif ( event == "SPELL_AURA_STOLEN" ) then
		spellId, spellName, spellSchool, extraSpellId, extraSpellName, extraSpellSchool, auraType = ...
		
	elseif ( event == "SPELL_AURA_APPLIED" ) and (self:isChecked("buff", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, auraType = ...
		--(source arguments are nil)
		buffNameColored = self:buffColoring(spellName, auraType, nil)
		output = "[DEST_NAME]"..buffNameColored
		
	elseif ( event == "SPELL_AURA_REMOVED" ) and (self:isChecked("buff", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, auraType = ...
		--(source arguments are nil)
		buffColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.skill.r, self.db.profile.colors.skill.g, self.db.profile.colors.skill.b)
		output = "[DEST_NAME]".."|c"..buffColor.." -- "..spellName.."|r"
		
	elseif ( event == "SPELL_AURA_APPLIED_DOSE" ) and (self:isChecked("buff", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, auraType, amount = ...
		--(source arguments are nil)
		buffNameColored = self:buffColoring(spellName, auraType, amount)
		output = "[DEST_NAME]"..buffNameColored
		
	elseif ( event == "SPELL_AURA_REMOVED_DOSE" ) and (self:isChecked("buff", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, auraType, amount = ...
		--(source arguments are nil)
		buffColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.skill.r, self.db.profile.colors.skill.g, self.db.profile.colors.skill.b)
		output = "[DEST_NAME]".."|c"..buffColor.." -- "..spellName.."("..amount..")|r"
		
	elseif ( event == "SPELL_CAST_START" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_CAST_SUCCESS" ) then
		spellId, spellName, spellSchool = ...
		
	elseif ( event == "SPELL_CAST_FAILED" ) and (self:isChecked("failed", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, failType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		output = spellNameColored..L[" Fail"]..": "..failType
		
		--Special Events
	elseif ( event == "DAMAGE_SHIELD" ) and (self:isChecked("cast", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		amountColored = self:colorSpellName(spellSchool, amount)
		buffNameColored = self:buffColoring(spellName, auraType, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		if critical == 1 then critical = L["Crit "] amountColored = "*"..amountColored.."*" else critical = "" end
		output = "[SOURCE_NAME] "..spellNameColored.." "..critical.."[DEST_NAME] "..amountColored..partialDamage
		
	elseif ( event == "DAMAGE_SPLIT" ) then
		spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...;
		
	elseif ( event == "DAMAGE_SHIELD_MISSED" ) and (self:isChecked("miss", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellId, spellName, spellSchool, missType = ...
		spellNameColored = self:colorSpellName(spellSchool, spellName)
		missed = self:SwingMissType(missType)
		output = "[SOURCE_NAME] "..spellNameColored.." [DEST_NAME] "..missed
		
	elseif ( event == "ENCHANT_APPLIED" ) and (self:isChecked("enchant", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellName, itemID, itemName = ...
		enchantNameColored = self:EnchantColoring(spellName, event)
		output = L["Enchant"]..": [SOURCE_NAME] "..enchantNameColored..L[" to"].." [DEST_NAME] "..itemName
		
	elseif ( event == "ENCHANT_REMOVED" ) and (self:isChecked("enchant", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		spellName, itemID, itemName = ...
		enchantNameColored = self:EnchantColoring(spellName, event)
		output = L["Enchant"]..": [DEST_NAME] "..enchantNameColored..L[" fades from: "]..itemName
		
	elseif ( event == "PARTY_KILL" ) and (self:isChecked("death", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		output = "[SOURCE_NAME] "..L["killed"].." [DEST_NAME]"
		
	elseif ( event == "UNIT_DESTROYED" ) and (self:isChecked("death", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true  then
		output = L["Death"]..": [DEST_NAME]"
		
	elseif ( event == "UNIT_DIED" ) and (self:isChecked("death", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true  then
		output = L["Death"]..": [DEST_NAME]"
		
	elseif ( event == "ENVIRONMENTAL_DAMAGE" ) and (self:isChecked("environment", sourceGUID, destGUID, sourceFlags, destFlags, sourceName, destName)) == true then
		environmentalType, amount, school, resisted, blocked, absorbed, critical, glancing, crushing = ...
		environmentalType = self:EnvironmentalDamageType(environmentalType)
		amountColored = self:colorSpellName(school, amount)
		partialDamage = self:partialDamage(resisted, blocked, absorbed, critical, glancing, crushing)
		output = "[DEST_NAME] "..environmentalType.." "..amountColored..partialDamage
	end
	
	if ( output ) then
		self:AddOutput(output, sourceName, sourceFlags, destName, destFlags)
		
		--[[if ( sourceName ) then
			local testone = ( string.gsub(sourceName, "-.+", "") )
			local playerClass, englishClass = UnitClass(testone);
			englishClass = tostring(englishClass)
			ChatFrame3:AddMessage("sourceName: "..testone.." class: "..englishClass)
		end
		if ( destName ) then
			local testtwo = ( string.gsub(destName, "-.+", "") )
			local playerClass, englishClass = UnitClass(testtwo)
			englishClass = tostring(englishClass)
			ChatFrame3:AddMessage("destName: "..testtwo.." class: "..englishClass)
		end]]--
		
	end

end

--Add message to chatframe
function YurrCombatLog:AddOutput(output, sourceName, sourceFlags, destName, destFlags)

	local sourceName, sourceFlags, destName, destFlags = sourceName, sourceFlags, destName, destFlags
	local output = output
	local timestampColor, timestamp, source, dest

	if ( self.db.profile.timestamp == true ) then
		timestampColor = self:CombatLog_Color_FloatToText(self.db.profile.colors.timestampColor.r, self.db.profile.colors.timestampColor.g, self.db.profile.colors.timestampColor.b)
		timestamp = "|c"..timestampColor..date("[%H:%M:%S]").."|r"
		output = timestamp..output
	end
	source = self:colorUnit(sourceName, sourceFlags)
	dest = self:colorUnit(destName, destFlags)
	if (source) then
		output = string.gsub(output, "(SOURCE_NAME)", source)
	else 
		output = string.gsub(output, "(SOURCE_NAME)", "N/A")
	end
	if (dest) then
		output = string.gsub(output, "(DEST_NAME)", dest)
	end
	output = string.gsub(output, (UnitName("Player")), "You")
	outputFrame:AddMessage(output)

end

--Experience
function YurrCombatLog:CHAT_MSG_COMBAT_XP_GAIN(event, fullexp)

	local event, fullexp = event, fullexp
	local output

	if( self.db.profile.events.experience == true ) then
		-- Quest
		-- You gain %d experience.
		experience = string.gsub(COMBATLOG_XPGAIN_FIRSTPERSON_UNNAMED, "(%%d)", "(.+)")
		start, stop, amount = string.find(fullexp, experience)
		if (amount) then
			output = L["Exp: "]..amount
		end
		
		-- Solo
		-- %s dies, you gain %d experience.
		experience = string.gsub(string.gsub(COMBATLOG_XPGAIN_FIRSTPERSON, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, amount = string.find(fullexp, experience)
		if (amount) then
			if (source) then
				output = L["Exp: "]..amount.."("..source..")"
			end
		end
		
		-- Solo rested
		-- %s dies, you gain %d experience. (%s exp %s bonus)
		experience = string.gsub(string.gsub(string.gsub(string.gsub(COMBATLOG_XPGAIN_EXHAUSTION1, "(%%s)", "(.+)"), "(%%d)", "(.+)"), "(%%s)", "(.+)"), "(%%s)", "(.+)");
		start, stop, source, amount, totalbonus, bonus, bonustype = string.find(fullexp, experience);
		if (amount) then
			if (source) then
				if (bonus) then
					bonus = string.sub(bonus, string.find(bonus, "+%d+", start))
					output = L["Exp: "]..amount.."("..source..")("..bonustype..bonus..")"
				end
			end
		end
		
		-- Grouped
		-- %s dies, you gain %d experience. (+%d group bonus)
		experience = string.gsub(string.gsub(string.gsub(COMBATLOG_XPGAIN_FIRSTPERSON_GROUP, "(%%s)", "(.+)"), "(%%d)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, amount, group = string.find(fullexp, experience)
		if (amount) then
			if (source) then
				if (group) then
					group = string.sub(group, string.find(group, "%d+", start))
					output = L["Exp: "]..amount.."("..source..")("..L["G+"]..group..")"
				end
			end
		end
		
		-- Grouped rested
		-- %s dies, you gain %d experience. (%s exp %s bonus, +%d group bonus)
		experience = string.gsub(string.gsub(string.gsub(string.gsub(COMBATLOG_XPGAIN_EXHAUSTION1_GROUP, "(%%s)", "(.+)"), "(%%d)", "(.+)"), "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, amount, totalbonus, bonus, bonustype, group = string.find(fullexp, experience)
		if (amount) then
			if (source) then
				if (bonus) then
					if (group) then
						bonus = string.sub(bonus, string.find(bonus, "+%d+", start))
						group = string.sub(group, string.find(group, "%d+", start))
						output = L["Exp: "]..amount.."("..source..")("..bonustype..bonus..")("..L["G+"]..group..")"
					end
				end
			end
		end
		self:AddOutput(output)
	end

end

--Honor
function YurrCombatLog:CHAT_MSG_COMBAT_HONOR_GAIN(event, fullhonor)

	local event, fullhonor = event, fullhonor
	local honor, start, stop, amount, output, rank

	if ( self.db.profile.events.honor == true ) then
		-- Honor
		-- You have been awarded %d honor points.
		honor = string.gsub(COMBATLOG_HONORAWARD, "(%%d)", "(.+)")
		start, stop, amount = string.find(fullhonor, honor)
		if (amount) then
		   output = L["Honor: "]..amount
		end
		
		-- HonorKill
		-- %s dies, honorable kill Rank: %s (%d Honor Points)
		honor = string.gsub(string.gsub(string.gsub(COMBATLOG_HONORGAIN, "(%%s)", "(.+)"), "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, source, rank, _, amount = string.find(fullhonor, honor)
		if (source) then
		   if (rank) then
		      if (amount) then
		         amount = string.sub(amount, string.find(amount, "%d+", start))
		         output = L["Honor: "]..amount.." ("..rank.." "..source..")"
		      end
		   end
		end
		self:AddOutput(output)
	end

end

--Reputation
function YurrCombatLog:CHAT_MSG_COMBAT_FACTION_CHANGE(event, fullrep)

	local event, fullrep = event, fullrep
	local gain, start, stop, faction, amount, output

	if( self.db.profile.events.faction == true ) then
		-- Reputation with %s increased by %d.
		gain = string.gsub(string.gsub(FACTION_STANDING_INCREASED, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, faction, amount = string.find(fullrep, gain)
		if (faction) then
			if (amount) then
				output = L["Rep: "]..faction.." +"..amount
			end
		end
		
		-- Reputation with %s decreased by %d.
		gain = string.gsub(string.gsub(FACTION_STANDING_DECREASED, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, faction, amount = string.find(fullrep, gain)
		if (faction) then
			if (amount) then
				output = L["Rep: "]..faction.." -"..amount
				gain, faction, amount = nil, nil, nil
			end
		end

	self:AddOutput(output)
	end

end

--Skillups
function YurrCombatLog:CHAT_MSG_SKILL(event, fullskillup)

	local event, fullskillup = event, fullskillup
	local start, stop, skill, amount, skillup, output

	if ( self.db.profile.events.skill == true ) then
		-- Skillup
		-- Your skill in %s has increased to %d.
		skillup = string.gsub(string.gsub(ERR_SKILL_UP_SI, "(%%s)", "(.+)"), "(%%d)", "(.+)")
		start, stop, skill, amount = string.find(fullskillup, skillup)
		if (skill) then
		   if (amount) then
		      output = L["Skill: "]..skill.."("..amount..")"
		      self:AddOutput(output)
		   end
		end
	end

end

--Combat
function YurrCombatLog:PLAYER_REGEN_ENABLED()

	local output
	
	if YurrCombatLog.db.profile.events.combat == true then
		output = " -- "..L["Combat"]
		self:AddOutput(output)
	end

end
function YurrCombatLog:PLAYER_REGEN_DISABLED()

	local output
	
	if YurrCombatLog.db.profile.events.combat == true then
		output = " ++ "..L["Combat"]
		self:AddOutput(output)
	end

end

function YurrCombatLog:getColor(info)
	return self.db.profile.colors[info[#info]].r, self.db.profile.colors[info[#info]].g, self.db.profile.colors[info[#info]].b
end
function YurrCombatLog:setColor(info, r, g, b)
	self.db.profile.colors[info[#info]] = { ["r"]=r, ["g"]=g, ["b"]=b }
end

function YurrCombatLog:getFilter(info)
	return self.db.profile[info[#info-4]][info[#info-3]][info[#info-1]][info[#info]]
end
function YurrCombatLog:setFilter(info, value)
	self.db.profile[info[#info-4]][info[#info-3]][info[#info-1]][info[#info]] = value
end

function YurrCombatLog:getEvents(info)
	return self.db.profile[info[#info-1]][info[#info]]
end
function YurrCombatLog:setEvents(info, value)
	self.db.profile[info[#info-1]][info[#info]] = value
end

isPlayer = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_MINE,
	COMBATLOG_OBJECT_REACTION_FRIENDLY,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_TYPE_PLAYER)
isPet = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_MINE,
	COMBATLOG_OBJECT_AFFILIATION_PARTY,
	COMBATLOG_OBJECT_AFFILIATION_RAID,
	COMBATLOG_OBJECT_AFFILIATION_OUTSIDER,
	COMBATLOG_OBJECT_REACTION_FRIENDLY,
	COMBATLOG_OBJECT_REACTION_NEUTRAL,
	COMBATLOG_OBJECT_REACTION_HOSTILE,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	COMBATLOG_OBJECT_TYPE_PET)
isRaid = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_RAID,
	COMBATLOG_OBJECT_REACTION_FRIENDLY,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	COMBATLOG_OBJECT_TYPE_PLAYER,
	COMBATLOG_OBJECT_TYPE_NPC,
	COMBATLOG_OBJECT_TYPE_PET,
	COMBATLOG_OBJECT_TYPE_GUARDIAN,
	COMBATLOG_OBJECT_TYPE_OBJECT)
isParty = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_PARTY,
	COMBATLOG_OBJECT_REACTION_FRIENDLY,
	COMBATLOG_OBJECT_REACTION_HOSTILE,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	COMBATLOG_OBJECT_TYPE_PLAYER,
	COMBATLOG_OBJECT_TYPE_NPC,
	COMBATLOG_OBJECT_TYPE_PET,
	COMBATLOG_OBJECT_TYPE_GUARDIAN,
	COMBATLOG_OBJECT_TYPE_OBJECT)
isTarget = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_OUTSIDER,
	COMBATLOG_OBJECT_REACTION_HOSTILE,
	COMBATLOG_OBJECT_REACTION_NEUTRAL,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	COMBATLOG_OBJECT_TYPE_NPC,
	COMBATLOG_OBJECT_TYPE_PLAYER)
--[[isTargetofTarget = bit.bor(
	)]]--
isFocus = bit.bor(
	COMBATLOG_OBJECT_FOCUS)
isOther = bit.bor(
	COMBATLOG_OBJECT_AFFILIATION_OUTSIDER,
	COMBATLOG_OBJECT_REACTION_FRIENDLY,
	COMBATLOG_OBJECT_REACTION_HOSTILE,
	COMBATLOG_OBJECT_CONTROL_PLAYER,
	COMBATLOG_OBJECT_CONTROL_NPC,
	COMBATLOG_OBJECT_TYPE_PLAYER,
	COMBATLOG_OBJECT_TYPE_NPC,
	COMBATLOG_OBJECT_TYPE_GUARDIAN,
	COMBATLOG_OBJECT_TYPE_OBJECT)


-- Copyright 2008 Copystring"